IF EXISTS (SELECT * FROM dbo.SysObjects WHERE id = object_id(N'dbo.AUDIT_upd_Ware') AND OBJECTPROPERTY(id, N'IsTrigger') = 1) DROP TRIGGER dbo.AUDIT_upd_Ware 
GO
CREATE TRIGGER [dbo].[AUDIT_upd_Ware]
ON [dbo].[Ware] FOR UPDATE NOT FOR REPLICATION AS
BEGIN
	

	DECLARE 
		@IDENTITY_SAVE			varchar(50),
		@AUDIT_LOG_TRANSACTION_ID	Int,
		@PRIM_KEY			nvarchar(4000),
		@Inserted	    		bit,
 		@ROWS_COUNT				int,
		@FK_UserIdNumber INT,
		@FK_CashBox INT,
		@ProgramPart SMALLINT,
		@TerminalName VARCHAR(50),
		@SystemDateStr VARCHAR(8),
		@SystemDateTime DATETIME

	SET NOCOUNT ON

	Select @ROWS_COUNT=count(*) from inserted
	SET @IDENTITY_SAVE = CAST(IsNull(@@IDENTITY,1) AS varchar(50))

    SELECT TOP 1 @FK_UserIdNumber = FK_UserIdNumber,
	@FK_CashBox = FK_CashBox,
	@ProgramPart = ProgramPart,
	@TerminalName = TerminalName
	FROM PersonnelLogInfo WITH (NOLOCK)
	WHERE spid = @@spid 
	ORDER BY CreateDate DESC

	IF ISNULL(@FK_UserIdNumber, 0) = 0
	  SET @FK_UserIdNumber = 1
	IF ISNULL(@FK_CashBox, -1) <= 0
	  SET @FK_CashBox = -1
	IF ISNULL(@ProgramPart, -1) <= 0
	  SET @ProgramPart = 14 -- ppUnknown from SystemAll
	IF ISNULL(@TerminalName, '') = ''
	  SET @TerminalName = 'Unknown'

    SELECT @SystemDateStr = SystemDate FROM System WITH (NOLOCK) WHERE Number = 1
    SET @SystemDateTime = CONVERT(DATETIME, @SystemDateStr + ' ' + CONVERT(CHAR(8), CURRENT_TIMESTAMP, 108))

	INSERT INTO dbo.AUDIT_LOG_TRANSACTIONS
	(
		TABLE_NAME,
		TABLE_SCHEMA,
		AUDIT_ACTION_ID,
		HOST_NAME,
		APP_NAME,
		MODIFIED_BY,
		MODIFIED_DATE,
		AFFECTED_ROWS,
		FK_UserIdNumber,
		FK_CashBox,
		ProgramPart,
		TerminalName,
		RealDateTime
	)
	values(
		'Ware',
		'dbo',
		1,	--	ACTION ID For UPDATE
		CASE 
		  WHEN LEN(HOST_NAME()) < 1 THEN ' '
		  ELSE HOST_NAME()
		END,
		CASE 
		  WHEN LEN(APP_NAME()) < 1 THEN ' '
		  ELSE APP_NAME()
		END,
		SUSER_SNAME(),
		@SystemDateTime,
		@ROWS_COUNT,
		@FK_UserIdNumber,
		@FK_CashBox,
		@ProgramPart,
		@TerminalName,
		GETDATE()
	)	
	
	Set @AUDIT_LOG_TRANSACTION_ID = SCOPE_IDENTITY()
	
	SET @Inserted = 0
	
	If UPDATE([WareName])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[WareNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[WareNumber], NEW.[WareNumber]), 0), '[WareNumber] Is Null')),
		    'WareName',
			CONVERT(nvarchar(4000), OLD.[WareName], 0),
			CONVERT(nvarchar(4000), NEW.[WareName], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[WareNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[WareNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[WareNumber], 0)=CONVERT(nvarchar(4000), OLD.[WareNumber], 0) or (NEW.[WareNumber] Is Null and OLD.[WareNumber] Is Null))
			where (
			
			
				(
					NEW.[WareName] <>
					OLD.[WareName]
				) Or
			
				(
					NEW.[WareName] Is Null And
					OLD.[WareName] Is Not Null
				) Or
				(
					NEW.[WareName] Is Not Null And
					OLD.[WareName] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([Price])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[WareNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[WareNumber], NEW.[WareNumber]), 0), '[WareNumber] Is Null')),
		    'Price',
			CONVERT(nvarchar(4000), OLD.[Price], 2),
			CONVERT(nvarchar(4000), NEW.[Price], 2),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[WareNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[WareNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[WareNumber], 0)=CONVERT(nvarchar(4000), OLD.[WareNumber], 0) or (NEW.[WareNumber] Is Null and OLD.[WareNumber] Is Null))
			where (
			
			
				(
					NEW.[Price] <>
					OLD.[Price]
				) Or
			
				(
					NEW.[Price] Is Null And
					OLD.[Price] Is Not Null
				) Or
				(
					NEW.[Price] Is Not Null And
					OLD.[Price] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([Payment])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[WareNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[WareNumber], NEW.[WareNumber]), 0), '[WareNumber] Is Null')),
		    'Payment',
			CONVERT(nvarchar(4000), OLD.[Payment], 0),
			CONVERT(nvarchar(4000), NEW.[Payment], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[WareNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[WareNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[WareNumber], 0)=CONVERT(nvarchar(4000), OLD.[WareNumber], 0) or (NEW.[WareNumber] Is Null and OLD.[WareNumber] Is Null))
			where (
			
			
				(
					NEW.[Payment] <>
					OLD.[Payment]
				) Or
			
				(
					NEW.[Payment] Is Null And
					OLD.[Payment] Is Not Null
				) Or
				(
					NEW.[Payment] Is Not Null And
					OLD.[Payment] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([ResultAccountNumber])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[WareNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[WareNumber], NEW.[WareNumber]), 0), '[WareNumber] Is Null')),
		    'ResultAccountNumber',
			CONVERT(nvarchar(4000), OLD.[ResultAccountNumber], 0),
			CONVERT(nvarchar(4000), NEW.[ResultAccountNumber], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[WareNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[WareNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[WareNumber], 0)=CONVERT(nvarchar(4000), OLD.[WareNumber], 0) or (NEW.[WareNumber] Is Null and OLD.[WareNumber] Is Null))
			where (
			
			
				(
					NEW.[ResultAccountNumber] <>
					OLD.[ResultAccountNumber]
				) Or
			
				(
					NEW.[ResultAccountNumber] Is Null And
					OLD.[ResultAccountNumber] Is Not Null
				) Or
				(
					NEW.[ResultAccountNumber] Is Not Null And
					OLD.[ResultAccountNumber] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([BalanceAccountNumber])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[WareNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[WareNumber], NEW.[WareNumber]), 0), '[WareNumber] Is Null')),
		    'BalanceAccountNumber',
			CONVERT(nvarchar(4000), OLD.[BalanceAccountNumber], 0),
			CONVERT(nvarchar(4000), NEW.[BalanceAccountNumber], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[WareNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[WareNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[WareNumber], 0)=CONVERT(nvarchar(4000), OLD.[WareNumber], 0) or (NEW.[WareNumber] Is Null and OLD.[WareNumber] Is Null))
			where (
			
			
				(
					NEW.[BalanceAccountNumber] <>
					OLD.[BalanceAccountNumber]
				) Or
			
				(
					NEW.[BalanceAccountNumber] Is Null And
					OLD.[BalanceAccountNumber] Is Not Null
				) Or
				(
					NEW.[BalanceAccountNumber] Is Not Null And
					OLD.[BalanceAccountNumber] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([MarkAsDeleted])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[WareNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[WareNumber], NEW.[WareNumber]), 0), '[WareNumber] Is Null')),
		    'MarkAsDeleted',
			CONVERT(nvarchar(4000), OLD.[MarkAsDeleted], 121),
			CONVERT(nvarchar(4000), NEW.[MarkAsDeleted], 121),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[WareNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[WareNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[WareNumber], 0)=CONVERT(nvarchar(4000), OLD.[WareNumber], 0) or (NEW.[WareNumber] Is Null and OLD.[WareNumber] Is Null))
			where (
			
			
				(
					NEW.[MarkAsDeleted] <>
					OLD.[MarkAsDeleted]
				) Or
			
				(
					NEW.[MarkAsDeleted] Is Null And
					OLD.[MarkAsDeleted] Is Not Null
				) Or
				(
					NEW.[MarkAsDeleted] Is Not Null And
					OLD.[MarkAsDeleted] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([PLUNumber])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[WareNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[WareNumber], NEW.[WareNumber]), 0), '[WareNumber] Is Null')),
		    'PLUNumber',
			CONVERT(nvarchar(4000), OLD.[PLUNumber], 0),
			CONVERT(nvarchar(4000), NEW.[PLUNumber], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[WareNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[WareNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[WareNumber], 0)=CONVERT(nvarchar(4000), OLD.[WareNumber], 0) or (NEW.[WareNumber] Is Null and OLD.[WareNumber] Is Null))
			where (
			
			
				(
					NEW.[PLUNumber] <>
					OLD.[PLUNumber]
				) Or
			
				(
					NEW.[PLUNumber] Is Null And
					OLD.[PLUNumber] Is Not Null
				) Or
				(
					NEW.[PLUNumber] Is Not Null And
					OLD.[PLUNumber] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([PriceInPercent])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[WareNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[WareNumber], NEW.[WareNumber]), 0), '[WareNumber] Is Null')),
		    'PriceInPercent',
			CONVERT(nvarchar(4000), OLD.[PriceInPercent], 0),
			CONVERT(nvarchar(4000), NEW.[PriceInPercent], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[WareNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[WareNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[WareNumber], 0)=CONVERT(nvarchar(4000), OLD.[WareNumber], 0) or (NEW.[WareNumber] Is Null and OLD.[WareNumber] Is Null))
			where (
			
			
				(
					NEW.[PriceInPercent] <>
					OLD.[PriceInPercent]
				) Or
			
				(
					NEW.[PriceInPercent] Is Null And
					OLD.[PriceInPercent] Is Not Null
				) Or
				(
					NEW.[PriceInPercent] Is Not Null And
					OLD.[PriceInPercent] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	-- Watch
	
	-- Lookup
	
	IF @Inserted = 0
	BEGIN
		DELETE FROM dbo.AUDIT_LOG_TRANSACTIONS WHERE AUDIT_LOG_TRANSACTION_ID = @AUDIT_LOG_TRANSACTION_ID
	END
	-- Restore @@IDENTITY Value  
    DECLARE @maxprec AS varchar(2)
    SET @maxprec=CAST(@@MAX_PRECISION as varchar(2))
    EXEC('SELECT IDENTITY(decimal('+@maxprec+',0),'+@IDENTITY_SAVE+',1) id INTO #tmp')
End
